#include "BSL_UART_Protocol_ROM.h"
#include "BSL_Command_Definitions_ROM.h"
#include "BSL_IO_UART.h"
#include "CRC.h"

/*******************************************************************************
*Function:    UART_ROM_RXPACKET
*Description: reads data vua UART communication
*Parameters:
*             dataBuffer *db        struct where read data will be stored
*Returns:
*             unsigned char         FLASH_ACK if operation was successfull
*******************************************************************************/
unsigned char UART_ROM_RXPacket(dataBuffer *db)
{
	unsigned char scrap_var;
	unsigned int i;
	if (UART_GetVerbose() == 1)
	{
		printf("\n-------------------------------------------------\n");
	}
	// 0x80 is read by TXPacket below
	scrap_var = readByte();             // first byte is always dummy
	scrap_var = readByte();             // second is size, disposable
	db->size = readByte();              // next size byte
	for (i = 0; i < db->size; i++)
	{
		db->data[i] = readByte();
	}
	scrap_var = readByte();             // CKL to do: check checksum
	scrap_var = readByte();             // CKH
	if (UART_GetVerbose() == 1)
	{
		printf("\n-------------------------------------------------\n");
	}
	return ROM_ACK;
}

/*******************************************************************************
*Function:    UART_ROM_TXPacket
*Description: writes data via UART communication to device
*Parameters:
*             dataBuffer db       a struct containing data
*Returns:
*             unsigned char       returns the readByte() answer
*******************************************************************************/
unsigned char UART_ROM_TXPacket(dataBuffer db)
{
	ROM_crc_init();
	return readByte();
}